/////////////////////////////////////////////////////////////
// CINEMA 4D SDK                                           //
/////////////////////////////////////////////////////////////
// (c) MAXON Computer GmbH, all rights reserved            //
/////////////////////////////////////////////////////////////

#ifndef C4D_INCLUDES_H__
#define C4D_INCLUDES_H__

#ifdef __API_INTERN__
abc def xyz
#endif

#include "description/bplayer.h"
#include "description/mbase.h"
#include "description/oarray.h"
#include "description/obase.h"
#include "description/obezier.h"
#include "description/ocamera.h"
#include "description/oextrude.h"
#include "description/offd.h"
#include "description/oinstance.h"
#include "description/olathe.h"
#include "description/olight.h"
#include "description/oloft.h"
#include "description/ometaball.h"
#include "description/onull.h"
#include "description/onurbscaps.h"
#include "description/oparticle.h"
#include "description/osky.h"
#include "description/onull.h"
#include "description/ospline.h"
#include "description/osweep.h"
#include "description/osymmetry.h"
#include "description/tbase.h"
#include "description/tcoffeeexpression.h"
#include "description/tcompositing.h"
#include "description/tdisplay.h"
#include "description/texpression.h"
#include "description/tmetaball.h"
#include "description/tmotionblur.h"
#include "description/tphong.h"
#include "description/trestriction.h"
#include "description/tsticktexture.h"
#include "description/ttargetexpression.h"
#include "description/ttexture.h"
#include "description/tuvw.h"
#include "description/tstop.h"
#include "description/xbase.h"
#include "description/xbitmap.h"
#include "description/mmaterial.h"
#include "description/millum.h"
#include "description/massign.h"
#include "description/mpreview.h"
#include "description/zmultipass.h"

#include "description/dbasedraw.h"

#include "description/bptexture.h"

#include "description/oboole.h"
#include "description/oattractor.h"
#include "description/obackground.h"
#include "description/obasedeform.h"
#include "description/obend.h"
#include "description/obulge.h"
#include "description/ocapsule.h"
#include "description/ocone.h"
#include "description/ocube.h"
#include "description/ocylinder.h"
#include "description/odeflector.h"
#include "description/odestructor.h"
#include "description/odisc.h"
#include "description/oenvironment.h"
#include "description/oexplosion.h"
#include "description/ofigure.h"
#include "description/ofloor.h"
#include "description/oforeground.h"
#include "description/oformula.h"
#include "description/ofractal.h"
#include "description/ofriction.h"
#include "description/ogravitation.h"
#include "description/oheadphone.h"
#include "description/oloudspeaker.h"
#include "description/omelt.h"
#include "description/omicrophone.h"
#include "description/ooiltank.h"
#include "description/oplane.h"
#include "description/oplatonic.h"
#include "description/opolyreduction.h"
#include "description/oprimitiveaxis.h"
#include "description/oprimitiveslice.h"
#include "description/opyramid.h"
#include "description/orelief.h"
#include "description/orotation.h"
#include "description/oshatter.h"
#include "description/oshear.h"
#include "description/osinglepoly.h"
#include "description/osphere.h"
#include "description/ospline4side.h"
#include "description/osplinearc.h"
#include "description/osplinecircle.h"
#include "description/osplinecissoid.h"
#include "description/osplinecogwheel.h"
#include "description/osplinecontour.h"
#include "description/osplinecycloid.h"
#include "description/osplineflower.h"
#include "description/osplineformula.h"
#include "description/osplinehelix.h"
#include "description/osplinenside.h"
#include "description/osplineprimitive.h"
#include "description/osplineprofile.h"
#include "description/osplinerectangle.h"
#include "description/osplinestar.h"
#include "description/osplinetext.h"
#include "description/ostage.h"
#include "description/otaper.h"
#include "description/otorus.h"
#include "description/otube.h"
#include "description/oturbulence.h"
#include "description/otwist.h"
#include "description/owind.h"
#include "description/owinddeform.h"
#include "description/owrap.h"
#include "description/osplinerail.h"
#include "description/osplinedeformer.h"
#include "description/osds.h"
#include "description/ospherify.h"
#include "description/oatomarray.h"
#include "description/oselection.h"
#include "description/oexplosionfx.h"
#include "description/tvibrate.h"
#include "description/taligntospline.h"
#include "description/taligntopath.h"
#include "description/tsunexpression.h"
#include "description/tlookatcamera.h"
#include "description/ofalloff_panel.h"
#include "description/ofalloff_standard.h"
#include "description/obaseeffector.h"
#include "description/oedeformer_panel.h"

#include "description/tooladdpoint.h"
#include "description/toolarrange.h"
#include "description/toolbase.h"
#include "description/toolbevel.h"
#include "description/toolbridge.h"
#include "description/toolbrush.h"
#include "description/toolcenter.h"
#include "description/toolclosehole.h"
#include "description/toolcreatepolygon.h"
#include "description/toolduplicate.h"
#include "description/tooledgecut.h"
#include "description/toolextrude.h"
#include "description/toolextrudeinner.h"
#include "description/toolfreeselection.h"
#include "description/tooliron.h"
#include "description/toolknife.h"
#include "description/toolliveselection.h"
#include "description/toolloopselection.h"
#include "description/toolmagnet.h"
#include "description/toolmakeselect.h"
#include "description/toolmatrixextrude.h"
#include "description/toolmeasure.h"
#include "description/toolmodelingaxis.h"
#include "description/toolmodify.h"
#include "description/toolmove.h"
#include "description/toolnormalmove.h"
#include "description/toolnormalscale.h"
#include "description/toolnormalrotate.h"
#include "description/toolpointweld.h"
#include "description/toolpolyselection.h"
#include "description/toolrandomize.h"
#include "description/toolrectselection.h"
#include "description/toolrotate.h"
#include "description/toolscale.h"
#include "description/toolsetvalue.h"
#include "description/toolslide.h"
#include "description/toolsmoothshift.h"
#include "description/toolstitchandsew.h"
#include "description/tooltransfer.h"
#include "description/toolextrude.h"
#include "description/toolmodelingaxis.h"

#include "description/ckmorph.h"
#include "description/ckpla.h"
#include "description/cksound.h"
#include "description/ctmorph.h"
#include "description/ctpla.h"
#include "description/ctsound.h"

#include "description/drendersettings.h"

#include "description/ctsound.h"

#endif // C4D_INCLUDES_H__

