#ifndef TRIBATTRIBUTES_H__
#define TRIBATTRIBUTES_H__

enum
{
	RIBATTRIBUTES_USESHADINGRATE						= 20301,
	RIBATTRIBUTES_SHADINGRATE							= 10301,
	RIBATTRIBUTES_USESHADINGINTERPOLATION				= 20302,
	RIBATTRIBUTES_SHADINGINTERPOLATION					= 10302,
		RIBATTRIBUTES_SHADINGINTERPOLATION_CONSTANT		= 0,
		RIBATTRIBUTES_SHADINGINTERPOLATION_SMOOTH		= 1,
	//RIBATTRIBUTES_MATTE								= 10005,
	RIBATTRIBUTES_USESIDES								= 20303,
	RIBATTRIBUTES_SIDES									= 10303,

	ID_ATTRIBUTES										= 10100,

	GROUP_GENERAL										= 10101,
	GROUP_TRACE											= 10102,
	GROUP_GI											= 10103,

	// PRMan
	RIBATTRIBUTES_PRM_USEMOTIONFACTOR					= 200060,	// Bool
	RIBATTRIBUTES_PRM_MOTIONFACTOR						= 100060,	// Real (Attribute)
	RIBATTRIBUTES_PRM_USEFOCUSFACTOR					= 200062,	// Bool
	RIBATTRIBUTES_PRM_FOCUSFACTOR						= 100062,	// Real (Attribute)

	RIBATTRIBUTES_PRM_TRACE_USEBIAS						= 200053,	// Bool
	RIBATTRIBUTES_PRM_TRACE_BIAS						= 100053,	// Real (Attribute)
	RIBATTRIBUTES_PRM_TRACE_USESAMPLEMOTION				= 200054,	// Bool
	RIBATTRIBUTES_PRM_TRACE_SAMPLEMOTION				= 100054,	// Bool (Attribute)
	RIBATTRIBUTES_PRM_TRACE_USEDISPLACEMENTS			= 200055,	// Bool
	RIBATTRIBUTES_PRM_TRACE_DISPLACEMENTS				= 100055,	// Bool (Attribute)
	RIBATTRIBUTES_PRM_TRACE_USEMAXDIFFUSEDEPTH			= 200057,	// Bool
	RIBATTRIBUTES_PRM_TRACE_MAXDIFFUSEDEPTH				= 100057,	// LONG (Attribute)
	RIBATTRIBUTES_PRM_TRACE_USEMAXSPECULARDEPTH			= 200058,	// Bool
	RIBATTRIBUTES_PRM_TRACE_MAXSPECULARDEPTH			= 100058,	// LONG (Attribute)

	RIBATTRIBUTES_PRM_GI_USEMAXERROR					= 200101,	// Real (Attribute)
	RIBATTRIBUTES_PRM_GI_MAXERROR						= 100101,	// Real (Attribute)
	RIBATTRIBUTES_PRM_GI_USEMAXPIXELDIST					= 200102,	// Real (Attribute)
	RIBATTRIBUTES_PRM_GI_MAXPIXELDIST					= 100102,	// Real (Attribute)


	RIBATTRIBUTES_DIRTY									= 60005,	// LONG (hidden dirty counter)


	// AIR
	RIBATTRIBUTES_AIR_USEMOTIONFACTOR					= 210060,
	RIBATTRIBUTES_AIR_MOTIONFACTOR						= 110060,
	RIBATTRIBUTES_AIR_USEFLATNESS						= 210061,
	RIBATTRIBUTES_AIR_FLATNESS							= 110061,

	RIBATTRIBUTES_AIR_RENDER_USETRUEDISPLACEMENT		= 210041,	// Bool
	RIBATTRIBUTES_AIR_RENDER_TRUEDISPLACEMENT			= 110041,	// Bool (Attribute)
	RIBATTRIBUTES_AIR_RENDER_USETRIANGLEDISPLACEMENT 	= 210042,	// Bool
	RIBATTRIBUTES_AIR_RENDER_TRIANGLEDISPLACEMENT		= 110042,	// Bool (Attribute)

	RIBATTRIBUTES_AIR_TRACE_USEBIAS						= 210053,	// Bool
	RIBATTRIBUTES_AIR_TRACE_BIAS						= 110053,	// Real (Attribute)
	RIBATTRIBUTES_AIR_TRACE_USEMOTIONBLUR				= 210054,	// Bool
	RIBATTRIBUTES_AIR_TRACE_MOTIONBLUR					= 110054,	// Bool (Attribute)
	RIBATTRIBUTES_AIR_TRACE_USEDISPLACEMENTS			= 210055,	// Bool
	RIBATTRIBUTES_AIR_TRACE_DISPLACEMENTS				= 110055,	// Bool (Attribute)

	RIBATTRIBUTES_AIR_GI_USEMAXERROR					= 210101,	// Bool
	RIBATTRIBUTES_AIR_GI_MAXERROR						= 110101,	// Real (Attribute)
	RIBATTRIBUTES_AIR_GI_USEMAXPIXELDIST				= 210102,	// Bool
	RIBATTRIBUTES_AIR_GI_MAXPIXELDIST					= 110102,	// Real (Attribute)
	RIBATTRIBUTES_AIR_GI_USENSAMPLES					= 210103,	// Bool
	RIBATTRIBUTES_AIR_GI_NSAMPLES						= 110103,	// LONG (Attribute)
	RIBATTRIBUTES_AIR_GI_USEADAPTIVESAMPLING			= 210107,	// Bool
	RIBATTRIBUTES_AIR_GI_ADAPTIVESAMPLING				= 110107,	// Bool (Attribute)
	RIBATTRIBUTES_AIR_GI_USEMAXHITDIST					= 210116,	// Bool
	RIBATTRIBUTES_AIR_GI_MAXHITDIST						= 110116,	// Bool (Attribute)

	// 3Delight
	RIBATTRIBUTES_3DL_USEMOTIONFACTOR				= 220060,	// Bool
	RIBATTRIBUTES_3DL_MOTIONFACTOR					= 120060,	// Real (Attribute)
	RIBATTRIBUTES_3DL_USEFOCUSFACTOR				= 220062,	// Bool
	RIBATTRIBUTES_3DL_FOCUSFACTOR					= 120062,	// Real (Attribute)

	RIBATTRIBUTES_3DL_TRACE_USEBIAS					= 220053,	// Bool
	RIBATTRIBUTES_3DL_TRACE_BIAS					= 120053,	// Real (Attribute)
	RIBATTRIBUTES_3DL_TRACE_USESAMPLEMOTION			= 220054,	// Bool
	RIBATTRIBUTES_3DL_TRACE_SAMPLEMOTION			= 120054,	// Bool (Attribute)
	RIBATTRIBUTES_3DL_TRACE_USEDISPLACEMENTS		= 220055,	// Bool
	RIBATTRIBUTES_3DL_TRACE_DISPLACEMENTS			= 120055,	// Bool (Attribute)

	RIBATTRIBUTES_3DL_GI_USESHADINGRATE				= 220102,	// Bool
	RIBATTRIBUTES_3DL_GI_SHADINGRATE				= 120102,	// Real (Attribute)
	RIBATTRIBUTES_3DL_GI_USEMAXERROR				= 220101,	// Bool
	RIBATTRIBUTES_3DL_GI_MAXERROR					= 120101	// Real (Attribute)

};

#endif // TRIBATTRIBUTES_H__
