#ifndef XVARIATION_H__
#define XVARIATION_H__

enum
{
	
	VARIATIONSHADER_SEED											= 1000,
	
	VARIATIONSHADER_SEED_MODE_GROUP						= 1001, // Group
	VARIATIONSHADER_SEED_MODE_OBJECT_CAT			= 1002, // LONG
	VARIATIONSHADER_SEED_MODE_OBJECT_OFF			= 0,
	VARIATIONSHADER_SEED_MODE_INSTANCE_ID			= 1,
	VARIATIONSHADER_SEED_MODE_OBJECT_NAME			= 2,
	VARIATIONSHADER_SEED_MODE_BUFFER_ID				= 3,
	VARIATIONSHADER_SEED_MODE_OBJECT_ID				= 4,
	VARIATIONSHADER_SEED_MODE_PARENT					= 5,
	
	VARIATIONSHADER_SEED_MODE_POLYGON_CAT			= 1003, // LONG
	VARIATIONSHADER_SEED_MODE_POLYGON_OFF			= 0,
	VARIATIONSHADER_SEED_MODE_POLYGON_ID			= 1,
	VARIATIONSHADER_SEED_MODE_POLYGON_SELECTION_TAG = 2,
	VARIATIONSHADER_SEED_MODE_POLYGON_UV_TILES = 3,
	VARIATIONSHADER_POLYGON_STEP							= 1006,
	
	VARIATIONSHADER_PROBABILITY								= 1004,
	VARIATIONSHADER_MASK											= 1005,

	VARIATIONSHADER_GRADING_GROUP							= 10000,	// Group
	VARIATIONSHADER_CONTRASTOFFSET						= 10001,
	VARIATIONSHADER_GAMMAOFFSET								= 10002,
	VARIATIONSHADER_HUEOFFSET									= 10003,
	VARIATIONSHADER_SATURATIONOFFSET					= 10004,
	VARIATIONSHADER_LIGHTNESSOFFSET						= 10005,
	VARIATIONSHADER_INVERTOFFSET							= 10006,

	VARIATIONSHADER_COLORIZE_GROUP						= 30000,	// Group
	VARIATIONSHADER_PRIMARY_TEXTURE						= 30001,
	VARIATIONSHADER_SECONDARY_TEXTURE					= 30003,
	VARIATIONSHADER_SECONDARY_TEXTURE_BLEND		= 30004,
	VARIATIONSHADER_GRADIENT									= 30005, // GRADIENT
	VARIATIONSHADER_GRADIENT_BLEND						= 30006, // GRADIENT
	VARIATIONSHADER_RANDOMCOLOROFFSET					= 30007,

	VARIATIONSHADER_BLEND_MODE								= 30008, // LONG
  // ITEM#150960 Variation Shader - Missing “Color Variation/…/Mode/Lighten” preview after selecting it from list.
  // IDs should not start at 0. I've upped the IDs by one
	VARIATIONSHADER_BLENDMODE_LIGHTEN					= 1,
	VARIATIONSHADER_BLENDMODE_DARKEN					= 2,
	VARIATIONSHADER_BLENDMODE_MULTIPLY				= 3,
	VARIATIONSHADER_BLENDMODE_AVERAGE					= 4,
	VARIATIONSHADER_BLENDMODE_ADD							= 5,
	VARIATIONSHADER_BLENDMODE_SUBTRACT				= 6,
	VARIATIONSHADER_BLENDMODE_DIFFERENCE			= 7,
	VARIATIONSHADER_BLENDMODE_NEGATION				= 8,
	VARIATIONSHADER_BLENDMODE_SCREEN					= 9,
	VARIATIONSHADER_BLENDMODE_EXCLUSION				= 10,
	VARIATIONSHADER_BLENDMODE_OVERLAY					= 11,
	VARIATIONSHADER_BLENDMODE_SOFTLIGHT				= 12,
	VARIATIONSHADER_BLENDMODE_HARDLIGHT				= 13,
	VARIATIONSHADER_BLENDMODE_COLORDODGE			= 14,
	VARIATIONSHADER_BLENDMODE_COLORBURN				= 15,
	VARIATIONSHADER_BLENDMODE_LINEARDODGE			= 16,
	VARIATIONSHADER_BLENDMODE_LINEARBURN			= 17,
	VARIATIONSHADER_BLENDMODE_LINEARLIGHT			= 18,
	VARIATIONSHADER_BLENDMODE_VIVIDLIGHT			= 19,
	VARIATIONSHADER_BLENDMODE_PINLIGHT				= 20,
	VARIATIONSHADER_BLENDMODE_HARDMIX					= 21,
	VARIATIONSHADER_BLENDMODE_REFLECT					= 22,
	VARIATIONSHADER_BLENDMODE_GLOW						= 23,
	VARIATIONSHADER_BLENDMODE_PHOENIX					= 24,
	VARIATIONSHADER_BLENDMODE_LEVR						= 25,
	VARIATIONSHADER_BLENDMODE_COLOR						= 26,
	VARIATIONSHADER_BLENDMODE_COLOR_INV				= 27,
	VARIATIONSHADER_BLENDMODE_NORMAL					= 28,
	VARIATIONSHADER_BLENDMODE_REPLACE					= 29,
	VARIATIONSHADER_BLENDMODE_SEP_1           = 3000,

	VARIATIONSHADER_SECONDARY_TEXTURE_MODE		= 30009, // LONG	
	VARIATIONSHADER_GRADIENT_MODE							= 30010, // LONG
	VARIATIONSHADER_RANDOMCOLOR_MODE					= 30011, // LONG

	VARIATIONSHADER_UVW_COORDINATES_GROUP			= 40000,	// Group
	VARIATIONSHADER_UVW_SHIFT									= 40001,
	VARIATIONSHADER_UVW_ROTATE								= 40003,
	VARIATIONSHADER_UVW_FLIP_X								= 40004,
	VARIATIONSHADER_UVW_FLIP_Y								= 40005,
	VARIATIONSHADER_UVW_ROTATE_QUANTIZE_GROUP	= 40006,	// Group
	VARIATIONSHADER_UVW_ROTATE_QUANTIZE_0			= 0,
	VARIATIONSHADER_UVW_ROTATE_QUANTIZE_45		= 1,
	VARIATIONSHADER_UVW_ROTATE_QUANTIZE_90		= 2,
	VARIATIONSHADER_UVW_ROTATE_QUANTIZE_180		= 3,
	

	VARIATIONSHADER_OPTIONS_GROUP							= 50000,	// Group
	VARIATIONSHADER_CLIPONE										= 50002
};

#endif // XVARIATION_H__
